require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SpeachbaloonsController do

  # This should return the minimal set of attributes required to create a valid
  # Speachbaloon. As you add validations to Speachbaloon, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all speachbaloons as @speachbaloons" do
      speachbaloon = Speachbaloon.create! valid_attributes
      get :index
      assigns(:speachbaloons).should eq([speachbaloon])
    end
  end

  describe "GET show" do
    it "assigns the requested speachbaloon as @speachbaloon" do
      speachbaloon = Speachbaloon.create! valid_attributes
      get :show, :id => speachbaloon.id
      assigns(:speachbaloon).should eq(speachbaloon)
    end
  end

  describe "GET new" do
    it "assigns a new speachbaloon as @speachbaloon" do
      get :new
      assigns(:speachbaloon).should be_a_new(Speachbaloon)
    end
  end

  describe "GET edit" do
    it "assigns the requested speachbaloon as @speachbaloon" do
      speachbaloon = Speachbaloon.create! valid_attributes
      get :edit, :id => speachbaloon.id
      assigns(:speachbaloon).should eq(speachbaloon)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Speachbaloon" do
        expect {
          post :create, :speachbaloon => valid_attributes
        }.to change(Speachbaloon, :count).by(1)
      end

      it "assigns a newly created speachbaloon as @speachbaloon" do
        post :create, :speachbaloon => valid_attributes
        assigns(:speachbaloon).should be_a(Speachbaloon)
        assigns(:speachbaloon).should be_persisted
      end

      it "redirects to the created speachbaloon" do
        post :create, :speachbaloon => valid_attributes
        response.should redirect_to(Speachbaloon.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved speachbaloon as @speachbaloon" do
        # Trigger the behavior that occurs when invalid params are submitted
        Speachbaloon.any_instance.stub(:save).and_return(false)
        post :create, :speachbaloon => {}
        assigns(:speachbaloon).should be_a_new(Speachbaloon)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Speachbaloon.any_instance.stub(:save).and_return(false)
        post :create, :speachbaloon => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested speachbaloon" do
        speachbaloon = Speachbaloon.create! valid_attributes
        # Assuming there are no other speachbaloons in the database, this
        # specifies that the Speachbaloon created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Speachbaloon.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => speachbaloon.id, :speachbaloon => {'these' => 'params'}
      end

      it "assigns the requested speachbaloon as @speachbaloon" do
        speachbaloon = Speachbaloon.create! valid_attributes
        put :update, :id => speachbaloon.id, :speachbaloon => valid_attributes
        assigns(:speachbaloon).should eq(speachbaloon)
      end

      it "redirects to the speachbaloon" do
        speachbaloon = Speachbaloon.create! valid_attributes
        put :update, :id => speachbaloon.id, :speachbaloon => valid_attributes
        response.should redirect_to(speachbaloon)
      end
    end

    describe "with invalid params" do
      it "assigns the speachbaloon as @speachbaloon" do
        speachbaloon = Speachbaloon.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Speachbaloon.any_instance.stub(:save).and_return(false)
        put :update, :id => speachbaloon.id, :speachbaloon => {}
        assigns(:speachbaloon).should eq(speachbaloon)
      end

      it "re-renders the 'edit' template" do
        speachbaloon = Speachbaloon.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Speachbaloon.any_instance.stub(:save).and_return(false)
        put :update, :id => speachbaloon.id, :speachbaloon => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested speachbaloon" do
      speachbaloon = Speachbaloon.create! valid_attributes
      expect {
        delete :destroy, :id => speachbaloon.id
      }.to change(Speachbaloon, :count).by(-1)
    end

    it "redirects to the speachbaloons list" do
      speachbaloon = Speachbaloon.create! valid_attributes
      delete :destroy, :id => speachbaloon.id
      response.should redirect_to(speachbaloons_url)
    end
  end

end
